lab_1/urls.py
from django.urls import path
from .views import index, friend_list

urlpatterns = [
    path('', index, name='index'),
    # Add friends path using friend_list Views
    path("friends", friend_list, name="friend list")
]

lab_2/urls.py
from lab_1.views import index
from django.urls import path
from django.urls.resolvers import URLPattern
from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('xml', views.xml, name='xml'),
    path('json', views.json, name='json')
]

lab_5/urls.py
from django.urls import path, include
from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('notes/<int:note_id>/', include([
        path('', views.get_note, name='get_note'),
        path('update', views.update_note, name='update_note'),
        path('delete', views.delete_note, name='delete_note'),
    ])),
]

praktikum/urls.py
from django.urls import path, re_path
from django.contrib import admin
import lab_1.urls as lab_1
from lab_1.views import index as index_lab1
from django.urls import path, re_path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('lab-1/', include('lab_1.urls')),
    re_path(r'^$', index_lab1, name='index'),
    path('lab-2/', include(('lab_2.urls', 'Lab_2'), namespace='Lab_2')),
    path('lab-3/', include('lab_3.urls')),
    path('lab-4/', include('lab_4.urls')),
    path('lab-5/', include('lab_5.urls')),
]

lab_5/models.py
from django.db import models

# Create your models here.

lab_5/forms.py
from typing import Text
from django.forms import ModelForm, TextInput, Textarea
from lab_2.models import Note

class NoteForm(ModelForm):
    class Meta:
        model = Note
        fields = ('to', 'from', 'title', 'message')
        widgets = {'to': TextInput(attrs={'class': 'form-control border-dark', 'id': 'inputTo'}),
                   'from': TextInput(attrs={'class': 'form-control border-dark', 'id': 'inputFrom'}),
                   'title': TextInput(attrs={'class': 'form-control border-dark', 'id': 'inputTitle'}),
                   'message': Textarea(attrs={'class': 'form-control border-dark', 'id': 'inputMessage', 'rows': '6'})}

lab_5/views.py
from django.shortcuts import render
from lab_2.models import Note
from django.http.response import HttpResponse
from django.core import serializers
from .forms import NoteForm
from django.http import JsonResponse

# Create your views here.
def index(request):
    note = Note.objects.all()
    form = NoteForm()
    response = {'notes': note, "form": form}
    return render(request, 'lab5_index.html', response)

def get_note(request, note_id):
    is_ajax = request.META.get('HTTP_X_REQUESTED_WITH') == 'XMLHttpRequest'
    if (is_ajax and request.method == 'GET'):
        note = Note.objects.filter(pk=note_id)
        data = serializers.serialize('json', note)
        return HttpResponse(data, content_type='application/json')

def update_note(request, note_id):
    is_ajax = request.META.get('HTTP_X_REQUESTED_WITH') == 'XMLHttpRequest'

    # request should be ajax and method should be POST.
    if (request.method == 'POST' and is_ajax):
        noteInstance = Note.objects.get(pk=note_id)
        # get the form data
        form = NoteForm(request.POST, instance=noteInstance)
        # save the data and after fetch the object in instance
        if form.is_valid():
            instance = form.save()
            # serialize in new note object in json
            ser_instance = serializers.serialize('json', [ instance, ])
            # send to client side.
            return JsonResponse({}, status=200)
        else:
            # some form errors occured.
            return JsonResponse({"error": form.errors}, status=400)

    # some error occured
    return JsonResponse({"error": ""}, status=400)

def delete_note(request, note_id):
    is_ajax = request.META.get('HTTP_X_REQUESTED_WITH') == 'XMLHttpRequest'

    # request should be ajax and method should be POST.
    if (request.method == 'POST' and is_ajax):
        noteInstance = Note.objects.get(pk=note_id)
        # Delete object
        noteInstance.delete()
        return JsonResponse({}, status = 200)
    else:
        # some error occured
        return JsonResponse({"error": ""}, status=400)

lab_5/templates/lab5_header.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1">

     <!-- Bootstrap CSS -->
     <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">

      <!-- JQuery Import -->
      <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>

      <script src="{% static 'js/function.js' %}"></script>

    <title>{% block tab_title %}Note{% endblock %}</title>
  </head>
  <body>
    <!--test navbar-->
    <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
      <div class="container-fluid">
        <span class="navbar-brand mb-0 h1">Note</span>
        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
          <div class="navbar-nav">
            <a class="nav-link" href="{% url 'index' %}">Table</a>
            <a class="nav-link disabled" href="/lab-4/note-list">Card</a>
            <a class="nav-link disabled" href="/lab-4/add-note">Add Note</a>
          </div>
        </div>
      </div>
    </nav>

    {% block content %}{% endblock %}

    <!-- Option 1: Bootstrap Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
  </body>
</html>

lab_5/templates/lab5_index.html
{% extends "lab5_header.html" %}

{% block tab_title %}Note Table Format{% endblock %}
{% block content %}
<div id="lab-2JsonLink" style="display: none;">{% url 'Lab_2:json' %}</div>
<!-- table format -->
<div id="noteTableContainer">
  <h3 class="ms-2 mt-2">Note List</h3>
  <br>
  <table class="table table-striped" id="noteTable">
    <thead>
      <tr>
        <th scope="col">To</th>
        <th scope="col">From</th>
        <th scope="col">Title</th>
        <th scope="col">Message</th>
        <th scope="col" colspan="3">Actions</th>
      </tr>
    </thead>
    <tbody></tbody>
  </table>
</div>

<!-- View Modal -->
<div class="modal fade" id="singleNoteModal" tabindex="-1" aria-labelledby="singleNoteLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered modal-xl">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="singleNoteLabel">Note View</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <h5 class="modal-from">From:</h5>
        <h6 class="text-muted modal-to">To:</h6>
        <p class="modal-message">Message</p>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
      </div>
    </div>
  </div>
</div>

<!-- Edit Modal -->
<div class="modal fade" id="editModal" tabindex="-1" aria-labelledby="editModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered modal-xl">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="editModalLabel">Note Edit</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <form method="POST" action="" id="editForm">
          {% csrf_token %}
          <div class="row mb-3 ms-1 me-1">
            <label for="inputTo" class="col-xl-1 col-lg-2 col-md-3 col-form-label">To:</label>
            <div class="col-xl-3 col-lg-4 col-md-12">
              {{ form.to }}
            </div>
          </div>
          <div class="row mb-3 ms-1 me-1">
            <label for="inputFrom" class="col-xl-1 col-lg-2 col-md-3 col-form-label">From:</label>
            <div class="col-xl-3 col-lg-4 col-md-12">
              {{ form.from }}
            </div>
          </div>
          <div class="row mb-3 ms-1 me-1">
            <label for="inputTitle" class="col-xl-1 col-lg-2 col-md-3 col-form-label">Title:</label>
            <div class="col-xl-3 col-lg-4 col-md-12">
              {{ form.title }}
            </div>
          </div>
          <div class="row mb-3 ms-1 me-1">
            <label for="inputMessage" class="col-lg-2 col-xl-1 col-form-label">Message:</label>
            <div class="col-xl-7 col-lg-8 col-md-12">
              {{ form.message }}
            </div>
          </div>
          <!-- Store note id here -->
          <p id="inputNoteId" class="visually-hidden"></p>
        </form>
      </div>
      <div class="modal-footer">
        <input type="submit" form="editForm" class="btn btn-primary" value="Submit" data-bs-dismiss="modal"/>
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
      </div>
    </div>
  </div>
</div>

<!-- Deletion Confirmation Modal -->
<div class="modal fade" id="deleteConfirmModal" tabindex="-1" aria-labelledby="deleteConfirmLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="deleteConfirmLabel">Delete Confirmation</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <p>Are you sure you want to delete this note? This action cannot be undone!</p>
        <p id="deleteNoteId" class="visually-hidden"></p>
      </div>
      <div class="modal-footer">
        <form method="POST" action="" id="deleteConfirmButton">
          {% csrf_token %}
          <button type="submit" class="btn btn-primary" data-bs-dismiss="modal">Submit</button>
        </form>
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
      </div>
    </div>
  </div>
</div>
{% endblock content %}